#include "memory.h"
#include "HID.h" 
#include "main.h"
#include "game.h"


 const u8 chip8_fontset[80] =
	{
		0xF0, 0x90, 0x90, 0x90, 0xF0, // 0
		0x20, 0x60, 0x20, 0x20, 0x70, // 1
		0xF0, 0x10, 0xF0, 0x80, 0xF0, // 2
		0xF0, 0x10, 0xF0, 0x10, 0xF0, // 3
		0x90, 0x90, 0xF0, 0x10, 0x10, // 4
		0xF0, 0x80, 0xF0, 0x10, 0xF0, // 5
		0xF0, 0x80, 0xF0, 0x90, 0xF0, // 6
		0xF0, 0x10, 0x20, 0x40, 0x40, // 7
		0xF0, 0x90, 0xF0, 0x90, 0xF0, // 8
		0xF0, 0x90, 0xF0, 0x10, 0xF0, // 9
		0xF0, 0x90, 0xF0, 0x90, 0x90, // A
		0xE0, 0x90, 0xE0, 0x90, 0xE0, // B
		0xF0, 0x80, 0x80, 0x80, 0xF0, // C
		0xE0, 0x90, 0x90, 0x90, 0xE0, // D
		0xF0, 0x80, 0xF0, 0x80, 0xF0, // E
		0xF0, 0x80, 0xF0, 0x80, 0x80  // F
	};
 
int main() {
	//srand(time(NULL));

	int scale=6; //6 * 64 = 384w / 6 * 32 = 192h
	int quit = 0;   
         int count=0;
         const u8 W=0xFF;
        
	// CPU Stuff

	u8 V[16];
	u16 I;
	u16 PC;
	u16 SP;
	u16 stack[16];
	u8 delay_t;
	u8 sound_t;

	// Ram
	u8 ram[4096];

	// Key
	u8 key[16];

	// GFX
	u8 gfx[64][32];
	u8 oldgfx[64][32];
	u8 draw;

	u16 opcode;

	// Initialize
	PC = 0x200;
	opcode = 0;
	I = 0;
	SP = 0;
	draw = 0;
	delay_t = 0;
	sound_t = 0;
         int x,y,w,h;
         int input=0;
	int i=0;
	int j=0;

	for(i=0; i < 16; ++i){
			V[i]=0;
	}

	for(i=0; i < 16; ++i){
			stack[i]=0;
	}

	for(i=0; i < 16; ++i){
			key[i]=0;
	}

	for(i=0; i < 4096; ++i){
			ram[i]=0;
	}

	for(i=0; i < 64; ++i){
		for(j=0; j < 32; ++j) {
			gfx[i][j]=0x0;
		}
	}

	for(i=0; i < 80; ++i) {
			ram[i] = chip8_fontset[i];
	}

	


	for(i=0; i <= fSize; i++) {
			ram[i+0x200] = buffer[i];
			
	}

        clear(240*100*3,0,TOP_LEFT_FRAME1);
        clear(240*100*3,0,TOP_LEFT_FRAME2);
        clear(240*100*3,0,TOP_RIGHT_FRAME1);
        clear(240*100*3,0,TOP_RIGHT_FRAME2);
        clear(240*80*3,0,SUB_FRAME1);
        clear(240*80*3,0,SUB_FRAME2);
        
        // Start emulation

	while(quit == 0) {

		opcode = ram[PC + 0];
		opcode <<= 8;
		opcode |= ram[PC + 1];
                  input=~read_word(HID);

		for(i=0; i < 16; ++i){
			key[i]=0;
	         }
			if (input) {
				switch(input & 0xFFF) {
						case KEY1: key[0x1] = 1; break;
						case KEY2: key[0x2] = 1; break;
						case KEY3: key[0x3] = 1; break;
						case KEYC: key[0xC] = 1; break;
						case KEY4: key[0x4] = 1; break;
						case KEY5: key[0x5] = 1; break;
						case KEY6: key[0x6] = 1; break;
						case KEYD: key[0xD] = 1; break;
						case KEY7: key[0x7] = 1; break;
						case KEY8: key[0x8] = 1; break;
						case KEY9: key[0x9] = 1; break;
						case KEYE: key[0xE] = 1; break;
						case KEYA: key[0xA] = 1; break;
						case KEY0: key[0x0] = 1; break;
						case KEYB: key[0xB] = 1; break;
						case KEYF: key[0xF] = 1; break;
						//case SDLK_ESCAPE: exit(1); break;
						default:;
				}
			}
		
                
		if (draw == 1) {
			x = 0;
			y = 0;
			h = 32*scale;
			w = 64*scale;
			//SDL_FillRect(screen, &rect, SDL_MapRGB(screen->format, 0, 0, 0));

			for (i=0; i<64; i++) {
				for (j=0; j<32; j++) {
					if ((gfx[i][j] ^ oldgfx[i][j])) {
						x = i*scale;
						y = j*scale;
						w = scale;
						h = scale;
						if (gfx[i][j] == 1) {
							//SDL_FillRect(screen, &rect, SDL_MapRGB(screen->format, 255, 255, 255));
                                                                drawFullBox(x,y+scale,w,h,W,0);
                                                              
                                                    
						}
						if (gfx[i][j] == 0) {
							//SDL_FillRect(screen, &rect, SDL_MapRGB(screen->format, 0, 0, 0));
                                                                drawFullBox(x,y+scale,w,h,0,0);
                                                                
						}
					}
				}
			}
			//SDL_Flip(screen);

			draw = 0;

		}

		switch(opcode & 0xF000) {

			case 0x0000: {
				switch(opcode & 0x00FF) {
					case 0x00E0: {
						for(i=0; i < 64; ++i) {
							for(j=0; j < 32; ++j) {
								gfx[i][j] = 0x0;
							}
						}
						draw = 1;
                                               
						PC += 2;
                                                clearScreen();
					}
					break;

					case 0X00EE: {
						SP--;
						PC = stack[SP];
						PC += 2;
					}
					break;

					default: {
							

					}
					break;
				}
			}
			break;

			case 0x1000: {
				PC = opcode & 0X0FFF;
			}
			break;

			case 0x2000: {
				stack[SP] = PC;
				SP++;
				PC = opcode & 0x0FFF;
			}
			break;

			case 0x3000: {
				if (V[(opcode & 0x0F00) >> 8] == (opcode & 0x00FF)) {
					PC += 4;
				} else {
					PC += 2;
				}
			}
			break;

			case 0x4000: {
				if (V[(opcode & 0x0F00) >> 8] != ((opcode & 0x00FF))) {
					PC += 4;
				} else {
					PC += 2;
				}
			}
			break;

			case 0x5000: {
				if (V[(opcode & 0x0F00) >> 8] == V[(opcode & 0x00F0) >> 4]) {
					PC += 4;
				} else {
					PC += 2;
				}
			}
			break;

			case 0x6000: {
				V[(opcode & 0x0F00) >> 8] = opcode & 0x00FF;
				PC += 2;
			}
			break;

			case 0x7000: {
				V[(opcode & 0x0F00) >> 8] += opcode & 0x00FF;
				PC += 2;
			}
			break;

			case 0x8000: {
				switch(opcode & 0x000F) {
					case 0x0000: {
						V[(opcode & 0x0F00) >> 8] = V[(opcode & 0x00F0) >> 4];
						PC += 2;
					}
					break;

					case 0x0001: {
						V[(opcode & 0x0F00) >> 8] |= V[(opcode & 0x00F0) >> 4];
						PC += 2;
					}
					break;

					case 0x0002: {
						V[(opcode & 0x0F00) >> 8] &= V[(opcode & 0x00F0) >> 4];
						PC += 2;
					}
					break;

					case 0x0003: {
						V[(opcode & 0x0F00) >> 8] ^= V[(opcode & 0x00F0) >> 4];
						PC += 2;
					}
					break;

					case 0x0004: {
						if (V[(opcode & 0x00F0) >> 4] > (0xFF - V[(opcode & 0x0F00) >> 8])) {
							V[0xF] = 1;
						} else {
							V[0xF] = 0;
						}
						V[(opcode & 0x0F00) >> 8] += V[(opcode & 0x00F0) >> 4];
						PC += 2;
					}
					break;

					case 0x0005: {
						if (V[(opcode & 0x00F0) >> 4] > V[(opcode & 0x0F00) >> 8]) {
							V[0xF] = 0;
						} else {
							V[0xF] = 1;
						}
						V[(opcode & 0x0F00) >> 8] -= V[(opcode & 0x00F0) >> 4];
						PC += 2;
					}
					break;

					case 0x0006: {
						V[0xF] = V[(opcode & 0x0F00) >> 8] & 0x1;
						V[(opcode & 0x0F00) >> 8] >>= 1;
						PC += 2;
					}
					break;

					case 0x0007: {
						if (V[(opcode & 0x0F00) >> 8] > V[(opcode & 0x00F0) >> 4]) {
							V[0xF] = 0;
						} else {
							V[0xF] = 1;
						}
						V[(opcode & 0x0F00) >> 8] = V[(opcode & 0x00F0) >> 4] - V[(opcode & 0x0F00) >> 8];
						PC += 2;
					}
					break;

					case 0x000E: {
						V[0xF] = V[(opcode & 0x0F00) >> 8] >> 7;
						V[(opcode & 0x0F00) >> 8] <<= 1;
						PC += 2;
					}
					break;

					default: {
						

					}
					break;
				}
			}
			break;

			case 0x9000: {
				if (V[(opcode & 0x0F00) >> 8] != V[(opcode & 0x00F0) >> 4]) {
					PC += 4;
				} else {
					PC += 2;
				}
			}
			break;

			case 0xA000: {
				I = opcode & 0x0FFF;
				PC += 2;
			}
			break;

			case 0xB000: {
				PC = (opcode & 0x0FFF) + V[0x0];
			}
			break;

			case 0xC000: {
				V[(opcode & 0x0F00) >> 8] = (count % 0xFF) & (opcode & 0x00FF);
				PC += 2;
			}
			break;

			case 0xD000: {
				u8 x = V[(opcode & 0x0F00) >> 8];
				u8 y = V[(opcode & 0x00F0) >> 4];
				u8 n = opcode & 0x000F;
				u8 pixel;

				V[0xF] = 0;

				for (i=0; i<64; i++) {
					for (j=0; j<32; j++) {
						oldgfx[i][j] = gfx[i][j];
					}
				}

				for(i=0; i < n; i++) {
					pixel = ram[I + i];
					for(j=0; j < 8; j++) {
						if((pixel & (0x80 >> j)) != 0) {
							if(gfx[x+j][y+i] == 1) {
								V[0xF] = 1;
							}
						gfx[x+j][y+i] ^= 1;
						}
					}
				}

				draw = 1;
				PC += 2;
			}
			break;

			case 0xE000: {
				switch(opcode & 0x00FF) {
					case 0x009E: {
						if (key[V[(opcode & 0x0F00) >> 8]] == 1) {
							key[V[(opcode & 0x0F00) >> 8]] = 0;
							PC += 4;
						} else {
							PC += 2;
						}
					}
					break;

					case 0x00A1 : {
						if (key[V[(opcode & 0x0F00) >> 8]] != 1) {
							PC += 4;
						} else {
							PC += 2;
						}
					}
					break;

					default: {
						

					}
					break;
				}
			}
			break;


			case 0xF000: {
				switch(opcode & 0x00FF) {
					case 0x0007: {
						V[(opcode & 0x0F00) >> 8] = delay_t;
						PC += 2;
					}
					break;

					case 0x000A: {
						int keypress = 0;

						for (i=0; i < 16; ++i) {
							if (key[i] != 0) {
								key[i] = 0;
								V[(opcode & 0x0F00) >> 8] = i;
								keypress = 1;
							}
						}

						if (keypress == 0) {
							break;
						}

						PC += 2;
					}
					break;

					case 0x0015: {
						delay_t = V[(opcode & 0x0F00) >> 8];
						PC += 2;
					}
					break;

					case 0x0018: {
						sound_t = V[(opcode & 0x0F00) >> 8];
						PC += 2;
					}
					break;

					case 0x001E: {
						if(I + V[(opcode & 0x0F00) >> 8] > 0xFFF) {
							V[0xF] = 1;
						} else {
							V[0xF] = 0;
						}
						I += V[(opcode & 0x0F00) >> 8];
						PC += 2;
					}
					break;

					case 0x0029: {
						I = V[(opcode & 0x0F00) >> 8] * 0x5;
						PC += 2;
					}
					break;

					case 0x0033: {
						ram[I] = V[(opcode & 0x0F00) >> 8] / 100;
						ram[I + 1] = (V[(opcode & 0x0F00) >> 8] / 10) % 10;
						ram[I + 2] = (V[(opcode & 0x0F00) >> 8] % 100) % 10;
						PC += 2;
					}
					break;

					case 0x0055: {
						for (i=0; i<=((opcode & 0x0F00) >> 8); ++i) {
							ram[I + i] = V[i];
						}
						// Original interpreter?
						I += ((opcode & 0x0F00) >> 8) + 1;
						PC += 2;
					}
					break;

					case 0x0065: {
						for (i=0; i<=((opcode & 0x0F00) >> 8); ++i) {
							V[i] = ram[I + i];
						}
						// Original interpreter?
						I += ((opcode & 0x0F00) >> 8) + 1;
						PC += 2;
					}
					break;

					default: {
						

					}
					break;
				}
			}
			break;

			default: {
				

			}
			break;
		}

	if(delay_t > 0) {
		delay_t--;
	}
	if(sound_t > 0) {
		sound_t--;
	}

 	wait(100);
         count++;
        
	}
	return 0;
}
